//  Memory_Helper_Exports.h
//
//  Galaxy Group
//  Minsk, Slavic Rus
//  https://www.councils.world/
//  Kozlov Sergey Aleksandrovitsch
//  Since 2025 year.

#pragma once

// The following ifdef block is the standard way of creating macros which make exporting
// from a DLL simpler. All files within this DLL are compiled with the MEMORYHELPER_EXPORTS
// symbol defined on the command line. This symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see
// MEMORYHELPER_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef MEMORY_HELPER_EXPORTS
#define MEMORY_HELPER_API __declspec(dllexport)
#else
#define MEMORY_HELPER_API __declspec(dllimport)
#endif

extern "C" typedef int (entrance_function_type)();
extern "C" typedef void (call_back_alarm_function_type)();

extern "C" typedef bool (set_call_back_alarm_function_type)(call_back_alarm_function_type* p);
extern "C" typedef bool (terminate_memory_helper_function_type)();

extern "C" MEMORY_HELPER_API int entrance();

extern "C" MEMORY_HELPER_API bool set_call_back_alarm_function(call_back_alarm_function_type* p);
extern "C" MEMORY_HELPER_API bool terminate_memory_helper();
