//  Memory_Helper_Exception.h
//
//  Galaxy Group
//  Minsk, Slavic Rus
//  https://www.councils.world/
//  Kozlov Sergey Aleksandrovitsch
//  Since 2025 year.

#pragma once

#include <exception>
#include <string>

namespace Galaxy_Group_Star
{
    namespace Exception
    {
        class Memory_Helper_Worker_Exception :
            public std::exception
        {
        public:
            Memory_Helper_Worker_Exception(std::wstring p);

            Memory_Helper_Worker_Exception(const Memory_Helper_Worker_Exception& p);

            Memory_Helper_Worker_Exception& operator=(const Memory_Helper_Worker_Exception& p);

            virtual std::wstring What();

            virtual ~Memory_Helper_Worker_Exception();

        private:
            std::wstring Reason;
        };
    }
}