
// Memory_Helper_TestDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "Memory_Helper_Test.h"
#include "Memory_Helper_TestDlg.h"
#include "afxdialogex.h"

#include "Test_Button.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMemoryHelperTestDlg dialog

CMemoryHelperTestDlg::CMemoryHelperTestDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MEMORY_HELPER_TEST_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMemoryHelperTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON1, Start_Test_Button);
}

BEGIN_MESSAGE_MAP(CMemoryHelperTestDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CMemoryHelperTestDlg::OnClickedButton1)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CMemoryHelperTestDlg message handlers

BOOL CMemoryHelperTestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMemoryHelperTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMemoryHelperTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMemoryHelperTestDlg::OnClickedButton1()
{
	Start_Test_Button.Start_Test();
}

void CMemoryHelperTestDlg::OnClose()
{
	Start_Test_Button.Stop_Test();

	CDialogEx::OnClose();
}
