//  Memory_Helper_Exception.cpp
//
//  Galaxy Group
//  Minsk, Slavic Rus
//  https://www.councils.world/
//  Kozlov Sergey Aleksandrovitsch
//  Since 2025 year.

#include "pch.h"
#include "Memory_Helper_Worker_Exception.h"

namespace Galaxy_Group_Star
{
	namespace Exception
	{
		Memory_Helper_Worker_Exception::Memory_Helper_Worker_Exception(std::wstring p)
			: Reason(p)
		{
		}

		Memory_Helper_Worker_Exception::Memory_Helper_Worker_Exception(const Memory_Helper_Worker_Exception& p)
		{
			Reason = p.Reason;
		}

		Memory_Helper_Worker_Exception& Memory_Helper_Worker_Exception::operator=(const Memory_Helper_Worker_Exception& p)
		{
			Reason = p.Reason;

			return *this;
		}

		std::wstring Memory_Helper_Worker_Exception::What()
		{
			return Reason;
		}

		Memory_Helper_Worker_Exception::~Memory_Helper_Worker_Exception()
		{

		}
	}
}